# Examples

| Example            | File                                           | Description                                                            |
| ------------------ | ---------------------------------------------- | ---------------------------------------------------------------------- |
| `3d_scene`         | [`3d_scene.rs`](./3d_scene.rs)                 | Render a webview as 3D canvas                                          |
| `change_detection` | [`change_detection.rs`](./change_detection.rs) | Control a `Webview` through the struct field changes                   |
| `commands`         | [`commands.rs`](./commands.rs)                 | Control a webview through event-based commands                         |
| `events`           | [`events.rs`](./events.rs)                     | Event based communication between Rust and Javascript                  |
| `local_assets`     | [`local_assets.rs`](./local_assets.rs)         | Use local folder as a document source through `webview://` protocol    |
| `react_ui`         | [`react_ui.rs`](./react_ui.rs)                 | Demonstrate integration of a [React](https://reactjs.org/) application |
| `toggle_url`       | [`toggle_url.rs`](./toggle_url.rs)             | URL change/toggle performance demonstration                            |
| `ui_with_html`     | [`ui_with_html.rs`](./ui_with_html.rs)         | UI/2D mode webview with content loaded from an URI                     |
| `ui_with_uri`      | [`ui_with_uri.rs`](./ui_with_uri.rs)           | UI/2D mode webview with static content from HTML file                  |
| `visibility`       | [`visibility.rs`](./visibility.rs)             | Demonstrates performance of spawn/despawn vs visibility change         |
